package org.avmdti.josast.util.mathematique;

import org.avmdti.josast.util.VectorFourDim;

public class Mathematique {
	/*
	 * sgp_math.c -- a part of the SGP - C Library
	 * 
	 * Copyright (c) 2001-2002 Dominik Brodowski (c) 1992-2000 Dr TS Kelso
	 * 
	 * This file is part of the SGP C Library.
	 * 
	 * This library is free software; you can redistribute it and/or modify it
	 * under the terms of the GNU Lesser General Public License as published by
	 * the Free Software Foundation; either version 2.1 of the License, or (at
	 * your option) any later version.
	 * 
	 * This library is distributed in the hope that it will be useful, but
	 * WITHOUT ANY WARRANTY; without even the implied warranty of
	 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
	 * General Public License for more details.
	 * 
	 * You should have received a copy of the GNU Lesser General Public License
	 * along with this library; if not, write to the Free Software Foundation,
	 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
	 * 
	 * This SGP C Library is based on the SGP4 Pascal Library by Dr TS Kelso.
	 * 
	 * You can reach Dominik Brodowski by electronic mail at devel@brodo.de and
	 * by paper mail at Hoehbergstrasse 4; 72074 Tuebingen; Germany
	 */

	/***************************************************************************
	 * -------------------------------------------------------------------
	 * -------------------------------- cube ----------------------------- *
	 * -------------------------------------------------------------------
	 */

	public static double cube(double x) {
		x = Math.pow(x, 3.0);
		return x;
	}

	/***************************************************************************
	 * -------------------------------------------------------------------
	 * --------------------------------- sqr ---------------------------- *
	 * -------------------------------------------------------------------
	 */

	public static double sqr(double x) {
		x *= x;
		return x;
	}

	/***************************************************************************
	 * -------------------------------------------------------------------
	 * ------------------------------ modulus ---------------------------- *
	 * -------------------------------------------------------------------
	 */

	public static double modulus(double arg1, double arg2) {
		double modu;
		modu = arg1 - Math.floor(arg1 / arg2) * arg2;
		if (modu >= 0)
			return modu;
		else {
			modu += arg2;
			return modu;
		}
		//	return -1; /* shouldn't happen */
	}

	/***************************************************************************
	 * -------------------------------------------------------------------
	 * ------------------------------- fmod2p ---------------------------- *
	 * -------------------------------------------------------------------
	 */

	public static double fmod2p(double x) {
		x = modulus(x, 2.0 * Math.PI);
		return x;
	}

	/***************************************************************************
	 * -------------------------------------------------------------------
	 * ------------------------------- radians --------------------------- *
	 * -------------------------------------------------------------------
	 */

	public static double radians(double x) {
		x *= Math.PI / 180.0;
		return x;
	}

	/***************************************************************************
	 * -------------------------------------------------------------------
	 * ------------------------------ Magnitude -------------------------- *
	 * -------------------------------------------------------------------
	 */

	public static void Magnitude(VectorFourDim v) {
		v.v[3] = Math.sqrt(sqr(v.v[0]) + sqr(v.v[1]) + sqr(v.v[2]));
	}

}